/*->h.arcs */


#define NAMELEN 1024


#define DNFILE  -1
#define DFLAT   -2


typedef struct heads
{
 int                name;    /* file name */

 int                modified:1;
 int                writecache:1;
 int                get:1;
 int                put:1;
 int                update:1;

 int                length;

 int                dirn;  /* -2==unopened dir, -1==file, else dir entries */

 int                load;
 int                exec;
 int                acc;

} heads;





typedef struct archive
{
 char       *  path;

 int           inuse:1;
 int           modified:1;
 int           ro:1;
 int           writecache:1;

 heads      *  hdr;
 int           nofiles;        /* no of files entries           */
 int           fmain;          /* no of files in root directory */

} archive;








extern int  *  posn;
extern int  *  lno;
extern int  *  fpos;
extern char ** obje;

extern int  *  posn2;
extern int  *  lno2;
extern int  *  fpos2;



extern os_error * levelstackcheck(int level);
extern int        parentof(archive * arc,int child);
extern int        noindir(int acn,int posn);
extern os_error * setnofiles(int acn,int n);
extern os_error * insentry(int acn,int fn,int ind,int size);
extern void       rementry(archive * arc,int fn,int size);

extern os_error * filepath(char * arcpath,int acn,int ins);
extern os_error * filepath1(char * arcpath,int acn,int ins);


extern archive * arc;
extern int       maxarc;



extern os_error * getarchandle(int * arcn);
extern os_error * scrapentry(int acn,int n,int size);
extern os_error * losearc(int acn);
extern os_error * closedir(int acn,int n,int * size);


extern os_error * arcsinit(void);






